
import java.io.*;
import java.util.*;


public class DataLoader {
    public Vector    dlgTable  = new Vector( 10 );
    public Vector    prxTable  = new Vector( 10 );
    public Hashtable envTable  = new Hashtable( 10 );
    public Hashtable pmtTable  = new Hashtable( 10 );


    public DataLoader() { }


    public void load( String prgtitle ) {
        try {
            BufferedReader br = new BufferedReader( new FileReader( prgtitle + ".txt" ) );
 
            while ( true ) {
                String line = br.readLine().trim();
                if      ( line.equals( prgtitle ) ) { break; }
                else if ( line.equals( "" ) || line.startsWith( "#" ) ) { continue; }

                else if ( line.startsWith( "Delegate" ) )  { readLines( br, dlgTable ); }
                else if ( line.startsWith( "Proxy" ) )     { readLines( br, prxTable ); }
                else if ( line.startsWith( "ENV" ) )       { readPairs( br, envTable ); }
                else if ( line.startsWith( "Parameter" ) ) { readPairs( br, pmtTable ); }
            }

            br.close();
        }
        catch ( Exception e ) {
            System.err.println( "Exception : " + e );
        }
    }


    void readLines( BufferedReader br, Vector table ) {
        try {
            while ( true ) {
                String line = br.readLine().trim();
                if      ( line.equals( "}" ) ) { break; }
                else if ( line.equals( "" ) || line.startsWith( "#" ) ) { continue; }
                else {
                    table.addElement( line );
                }
            }
        }
        catch ( Exception e ) {
            System.err.println( "Exception : " + e );
        }
    }


    void readPairs( BufferedReader br, Hashtable table ) {
        try {
            while ( true ) {
                String line = br.readLine().trim();
                if      ( line.equals( "}" ) ) { break; }
                else if ( line.equals( "" ) || line.startsWith( "#" ) ) { continue; }
                else {
                    StringTokenizer st = new StringTokenizer( line, "=", false );
                    String name, value;
                    if ( st.hasMoreTokens() ) {
                        name  = st.nextToken().trim();
                        if ( st.hasMoreTokens() )
                             value = st.nextToken().trim();
                        else value = "";

                        table.put( name, value );
                    }
                }
            }
        }
        catch ( Exception e ) {
            System.err.println( "Exception : " + e );
        }
    }


}
