
import java.io.*;
import java.net.*;
import java.util.*;


public class GDSession extends Thread {
    protected static GabriDuke  gabriDuke    = null;

    protected Socket            clientSocket = null;
    protected DataInputStream   clientIn     = null;
    protected DataOutputStream  clientOut    = null;

    protected Socket            serverSocket = null;
    protected DataInputStream   serverIn     = null;
    protected DataOutputStream  serverOut    = null;


    public static void setGabriDuke( GabriDuke gd ) {
        gabriDuke  = gd;
    }


    public GDSession( Socket socket ) {
        clientSocket  = socket;
    }


    private void close() {
        try {
            if ( serverIn     != null ) { serverIn.close(); }
            if ( serverOut    != null ) { serverOut.close(); }
            if ( serverSocket != null ) { serverSocket.close(); }

            if ( clientIn     != null ) { clientIn.close(); }
            if ( clientOut    != null ) { clientOut.close(); }
            if ( clientSocket != null ) { clientSocket.close(); }

            super.stop();
        }
        catch ( Exception e ) {
            System.out.println( "Exception : " + e );
        }
    }


    public void run() {
        String  request   = null;
        String  method    = null;
        String  version   = null;
        String  strUrl    = null;
        URL     serverUrl = null;
        int     cLength   = 0;
 
        String  proxy     = gabriDuke.getProxy();
        String  delegate  = gabriDuke.getDelegate();
        String  fields    = gabriDuke.getFields();
        String  content   = null;

        String  linesp    = "\r\n";

        try {
            clientIn  = new DataInputStream ( new BufferedInputStream ( clientSocket.getInputStream () ) );
            clientOut = new DataOutputStream( new BufferedOutputStream( clientSocket.getOutputStream() ) );

            request = clientIn.readLine();
            StringTokenizer tk = new StringTokenizer( request, " ", false );

            if ( tk.hasMoreTokens() ) method  = tk.nextToken();
            if ( tk.hasMoreTokens() ) strUrl  = cut_str( tk.nextToken() );
            if ( tk.hasMoreTokens() ) version = tk.nextToken();

            while ( true ) {
                String line = clientIn.readLine();
                if ( line == null || line.equals("") ) {
                    break;
                }
                else if ( line.toUpperCase().indexOf( "CONTENT-LENGTH" ) > -1 ) {
                    tk = new StringTokenizer( line, ":", false );
                    if ( tk.countTokens() >= 2 ) {
                        tk.nextToken();
                        cLength = Integer.parseInt( tk.nextToken().trim() );
                    }
                }
            }

            if ( cLength > 0 ) {
                byte[] b = new byte[ cLength ];
                clientIn.read( b );
                content = new String( b );
            }

        }
        catch ( Exception e ) {
            System.out.println(      "ClientAccess Exception : " + e );
            replyInvalid( clientOut, "ClientAccess Exception" );
            close();
            return;
        }


        try {
            if ( proxy.equals("") ) {
                serverUrl = new URL( strUrl );
                request   = method + " " + serverUrl.getFile() + " " + version + linesp;
            }
            else {
                serverUrl = new URL( proxy );
                request   = method + " " + delegate + strUrl   + " " + version + linesp;
            }

            serverSocket = new Socket( serverUrl.getHost(),
                                       serverUrl.getPort () != -1 ? serverUrl.getPort () : 80 );
            serverIn  = new DataInputStream ( new BufferedInputStream ( serverSocket.getInputStream () ) );
            serverOut = new DataOutputStream( new BufferedOutputStream( serverSocket.getOutputStream() ) );

            serverOut.writeBytes( request );
            serverOut.writeBytes( fields );

            if ( cLength > 0 ) {
                serverOut.writeBytes( "Content-Length: " + cLength + linesp + linesp );
                serverOut.writeBytes( content );
                //streamCopyBytes( clientIn, serverOut );
            }

            serverOut.writeBytes( linesp );
            serverOut.flush();
            streamCopyBytes( serverIn, clientOut );

        }
        catch ( Exception e ) {
            System.out.println(      "ServerAccess Exception : " + e );
            replyInvalid( clientOut, "ServerAccess Exception : " + serverUrl );
            close();
            return;
        }

        close();
    }


    private String cut_str( String str ) {
        try {
            int idx = str.indexOf('@');
            if ( idx >= 0 ) {
                return str.substring( 0, str.indexOf("//") + 2 ) +
                       str.substring( idx + 1 );
            }
            else return str;
        }
        catch ( Exception e ) {
            return str;
        }
    }


    private void streamCopyBytes( DataInputStream in, DataOutputStream out ) {
        int      len    = 0;
        byte[]   buffer = new byte[ 1024 ];

        try {
            while ( true ) {
                len = in.read( buffer );
                if ( len < 0 )
                    break;
                if ( len > 0 ) {
                    out.write( buffer, 0, len );
                    out.flush();
                }
            }
        }
        catch ( IOException e ) { }
    }


    private void replyInvalid( DataOutputStream os, String message ) {
        try {
            StringBuffer sb = new StringBuffer();
            sb.append( "<HTML><HEAD><TITLE>Error</TITLE></HEAD>" );
            sb.append( "<BODY>" );
            sb.append( "<H2>Error</H2><BR><BR><P>" );
            sb.append( message );
            sb.append( "<BR><BR><HR><BR>" );
            sb.append( "<I><Font size=3 Color=#0000ff> GabriDUKE</Font></I>" );
            sb.append( "</BODY></HTML>" );

            os.writeBytes( sb.toString() );
            os.flush();
        }
        catch ( Exception e ) {
            System.out.println( "replyInvalid Exception : " + e );
        }

    }


}
